[Setup]
AppName=Game
AppVerName=Game
DefaultDirName={pf}\Game
OutputDir=.

[Files]
Source: compiler:WizModernSmallImage.bmp; DestDir: {tmp}; Flags: dontcopy
Source: compiler:Examples\MyProg.exe; DestDir: {app}

[Registry]
Root: HKLM; Subkey: Software\Game; ValueType: string; ValueName: Path; ValueData: {app}\MyProg.exe; Flags: uninsdeletekey

[Code]
var
  Image: TBitmapImage;
  PlayButton, RepairButton: TButton;
  AppPath: string;
  Res: Integer;

procedure PlayOnClick(Sender: TObject);
begin
  if RegQueryStringValue(HKLM, 'SOFTWARE\Game','Path', AppPath) then
  begin
    Exec(AppPath,'','',SW_SHOWNORMAL,ewNoWait,Res)
  end
end;

procedure RepairOnClick(Sender: TObject);
begin
  RepairButton.Hide
  PlayButton.Hide
  Image.Hide
end;

procedure InitializeWizard();
begin
  ExtractTemporaryFile('WizModernSmallImage.bmp')

  if RegQueryStringValue(HKLM, 'SOFTWARE\Game','Path', AppPath) then
  begin
    Image:=TBitmapImage.Create(WizardForm)
    Image.Left:=0
    Image.Top:=0
    Image.Stretch:=True
    Image.Align:=Alclient
    Image.Bitmap.LoadFromFile(ExpandConstant('{tmp}\WizModernSmallImage.bmp'))
    Image.Parent:=WizardForm.WelcomePage

    PlayButton:=TButton.Create(WizardForm)
    PlayButton.Left:=WizardForm.BackButton.Left
    PlayButton.Top:=WizardForm.BackButton.Top
    PlayButton.Width:=WizardForm.BackButton.Width
    PlayButton.Height:=WizardForm.BackButton.Height
    PlayButton.Caption:='Play'
    PlayButton.OnClick:=@PlayOnClick
    PlayButton.Parent:=WizardForm

    RepairButton:=TButton.Create(WizardForm)
    RepairButton.Left:=WizardForm.NextButton.Left
    RepairButton.Top:=WizardForm.NextButton.Top
    RepairButton.Width:=WizardForm.NextButton.Width
    RepairButton.Height:=WizardForm.NextButton.Height
    RepairButton.Caption:='Repair'
    RepairButton.OnClick:=@RepairOnClick
    RepairButton.Parent:=WizardForm
  end
end;