[Setup]
AppName=Components Descriptions
AppVerName=Components Descriptions
CreateAppDir=false

[Languages]
Name: ru; MessagesFile: compiler:Languages\Russian.isl

[Messages]
BeveledLabel=(c) Victor Dobrov

[Types]
Name: tweak; Description:  
Name: full; Description:   
Name: deselect; Description:   
Name: custom; Description:  ; Flags: iscustom

[Components]
Name: Safe; Description:  ; Types: deselect
Name: Safe\wscsvc; Description:  '  '; Types: full tweak
Name: Safe\Signing; Description:    ; Types: full
Name: WB; Description: ' ' - ; Types: deselect
Name: WB\Computer; Description:   - ,  ; Types: full tweak
Name: WB\Low; Description:       
Name: WB\Low\1; Description:     10 %  1%; Flags: exclusive; Types: tweak
Name: WB\Low\No; Description:     ; Flags: exclusive; Types: full
Name: IE; Description:   Internet Explorer; Types: deselect
Name: IE\Cache; Description:   Internet -  ; Types: full tweak
Name: User; Description:    
Name: User\Logon; Description:  -   ; Flags: exclusive; Types: full
Name: User\Logon2K; Description:   -     ; Flags: exclusive; Types: tweak
Name: User\Autologon; Description:     ; Types: full tweak
Name: User\Sound; Description:       ; Types: full
Name: User\English; Description:       ; Types: full
Name: Sys; Description:    ; Types: deselect
Name: Sys\Memory; Description:  -    Windows
Name: Sys\Memory\1024; Description: 1024     ; Flags: exclusive
Name: Sys\Timeout; Description:    ; Types: full tweak

[Files]
Source: compiler:descctrl.dll; Flags: dontcopy
;   descctrl.dll (6 )  : http://victor-dobrov.narod.ru/inno_descctrl.7z

[Code]
var Point: TPoint; CompDesc: TEdit; MessageForm: TForm; MessagePanel: TPanel; MessageLabel: TLabel; n, frame: integer;

function EnableDesc(ComponentsListHandle, DescLabelHandle: HWND; DescStrings: PChar): BOOL; external 'enabledesc@files:descctrl.dll stdcall';
function disabledesc(): BOOL; external 'disabledesc@files:descctrl.dll stdcall';
procedure GetCursorPos(var Point: TPoint); external 'GetCursorPos@user32 stdcall delayload';
function SetWindowPos(hWnd, hWndInsertAfter, X, Y, cx, cy, wFlags: Longint):Boolean; external 'SetWindowPos@user32.dll stdcall';
function ExtractIcon(hInst: LongInt; lpszExeFileName: PChar; nIconIndex: LongInt): LongInt; external 'ExtractIconA@shell32 stdcall delayload';
function DrawIconEx(hdc, x, y, hIcon, cx, cy, AniCur, Draw, Flags: Longint): Longint; external 'DrawIconEx@user32 stdcall delayload';
function GetModuleHandle(lpModuleName: LongInt): LongInt; external 'GetModuleHandleA@kernel32 stdcall delayload';

Procedure DrawIcon(Form: TWinControl; File: String; nIcon, Left, Top, Size, BColor: Integer); var Panel: TPanel; Rect: TRect; Begin
  Panel:= TPanel.Create(Form); Panel.SetBounds(Left, Top, Size, Size); Panel.Parent:= Form
  with TBitmapImage.Create(Panel) do begin Parent:= Panel; with Bitmap do begin
	  Width:= Size; Height:= Size; Rect.Right:= Size; Rect.Bottom:= Size; Canvas.Brush.Color:= BColor; Canvas.FillRect(Rect);
  DrawIconEx(Canvas.Handle, 0,0, ExtractIcon(GetModuleHandle(0), ExpandConstant(File), nIcon), Size, Size,0,0,3); end; end;
End;

Procedure ResizeLabel(Obj: TLabel; Text: String; MaxWidth: Integer); var k, w, h: integer;	Begin	{     }
	Obj.AutoSize:= true; Obj.WordWrap:= false; Obj.Caption:= Text; { }
	w:= Obj.Width; h:= Obj.Height; n:= (w + frame*2)/MaxWidth + 1
  Repeat
	Obj.Width:= w/n + frame*2*n + k
	Obj.Height:= h * n
	Obj.WordWrap:= true; k:= k + 4
  Until Obj.Height/h = n
End;

Procedure ShowHint(String: string; AIndex: Integer; Center: Bool); Begin	{     ,  AIndex = 0,   }
	frame:= 10; if AIndex <> 0 then String:= '      '+ String;
  GetCursorPos(Point); MessageLabel.Left:= frame; MessageLabel.Top:= frame
	ResizeLabel(MessageLabel, String, WizardForm.ClientWidth)
	if Center then n:= WizardForm.Left + WizardForm.Width/2 - (MessageLabel.Width + frame*2 -2)/2 else n:= Point.X + 12
  MessageForm.SetBounds(n, Point.Y + 12, MessageLabel.Width + frame*2 -2, MessageLabel.Height + frame*2 -2)
	if AIndex <> 0 then DrawIcon(MessageForm, '{sys}\shell32.dll', AIndex, 9, 8, 16, MessagePanel.Color);
	MessageForm.Show; SetWindowPos(MessageForm.Handle, -1, 0, 0, 0, 0, 3);
End;

Procedure DeinitializeSetup();
Begin
	disabledesc();
End;

Procedure CurStepChanged(CurStep: TSetupStep);
Begin
	if CurStep = ssInstall then disabledesc();
End;

Procedure CurPageChanged(CurPageID: Integer);
Begin
  if CurPageID = wpSelectComponents then enableDesc(WizardForm.ComponentsList.Handle,CompDesc.Handle,
	' .          .        .              255 .;' +
	'    (     );' +
	'    (      );' +
	'  -  ,    ;' +
	'          ;' +
	'         ;' +
	'    10 % ( -)  1% (    );' +
	'       ;' +
	'   Internet Explorer;' +
	'   Internet Explorer      NTFS;' +
	'   ;' +
	' -    (  ,   Windows XP);' +
	'  -      ( ,   Windows 2000);' +
	'            ;' +
	'       (    );' +
	'       (  );' +
	'         ,   ;' +
	'        ;' +
	'       ;' +
	'    (     )'
	);
End;

Procedure ObjectOnClick(Sender: TObject);
Begin
  Case TObject(Sender) of	{  }
	CompDesc:
		if CompDesc.Text > '' then ShowHint(CompDesc.Text, -1001, true) else MessageForm.Hide;
	MessageForm:
		WizardForm.BringToFront;
  end;
End;

Procedure InitializeWizard;
Begin
  CompDesc:= TEdit.Create(WizardForm)
	CompDesc.Parent:= WizardForm
	CompDesc.Visible:= false
	CompDesc.OnChange:= @ObjectOnClick
  MessageForm:= CreateCustomForm;
	MessageForm.BorderStyle:= bsNone
	MessageForm.OnActivate:= @ObjectOnClick
  MessagePanel:= TPanel.Create(MessageForm)
	MessagePanel.BevelInner:= bvLowered;
	MessagePanel.Align:= alClient;
	MessagePanel.Color:= $E1FFFF;
	MessagePanel.Parent:= MessageForm
  MessageLabel:= TLabel.Create(MessagePanel)
	MessageLabel.Transparent:= true
	MessageLabel.Font.Name:= 'Arial'
	MessageLabel.Font.Size:= WizardForm.Font.Size + 1
	MessageLabel.Parent:= MessagePanel
End;

