[Setup]
AppName=Calc DirSize
AppVerName=Calc DirSize
CreateAppDir=false

[Code]
type
	TMsg = record hWnd: HWnd; Msg, wParam, lParam: LongInt; Time: DWord; Pt: TPoint; end;
//	TMsg = record hWnd: HWnd; Msg, wParam, lParam, Time: DWord; Pt: TPoint; end;
var
    Browse, SizeButton: TButton; LSize: TLabel; Folder: String; EscFlag: Boolean; Msg: TMsg; HintForm: TSetupForm; HintPanel: TPanel;
const
    oneMB= 1024*1024; VK_SHIFT = $10; VK_ESCAPE = 27; WM_LBUTTONDOWN = $0201; WM_LBUTTONUP = $0202; WM_LBUTTONDBLCLK = $0203;

function PeekMessage(var Msg: TMsg; Wnd: HWnd; MsgFilterMin, MsgFilterMax, wRemoveMsg: LongInt): LongInt; external 'PeekMessageA@user32.dll stdcall';
function TranslateMessage(var Msg: TMsg): Boolean; external 'TranslateMessage@user32.dll stdcall';
function DispatchMessage(var Msg: TMsg): LongInt; external 'DispatchMessageA@user32.dll stdcall';

Function ByteOrGB(Bytes: Extended; noMB: Boolean): String; {     /// ( 3   )}
Begin
    if not noMB then Result:= FloatToStr(Int(Bytes)) +' Mb' else if Bytes < 1024 then if Bytes = 0 then Result:= '0' else Result:= FloatToStr(Int(Bytes)) +' Bt' else if Bytes/1024 < 1024 then Result:= FloatToStr(round((Bytes/1024)*10)/10) +' Kb' else If Bytes/oneMB < 1024 then Result:= FloatToStr(round(Bytes/oneMB*100)/100) +' Mb' else
    Result:= FloatToStr(round(Bytes/oneMB/1024*1000)/1000) +' Gb'; StringChange(Result, ',', '.')
End;

Function Size64(Hi, Lo: Integer): Extended;
Begin
    Result:= Lo; if Lo< 0 then Result:= Result + $7FFFFFFF + $7FFFFFFF + 2; for Hi:= Hi-1 Downto 0 do Result:= Result + $7FFFFFFF + $7FFFFFFF + 2;
End;

Procedure KeyPress(const Key: Word; var Press: Boolean);
Begin
//    if Press then Exit;
    if PeekMessage(Msg, 0, WM_LBUTTONDOWN, WM_LBUTTONDBLCLK, 1) <> 0 then Press:= True else Exit;
//    TranslateMessage(Msg); DispatchMessage(Msg);
End;

function CalcDirSize(const fromDir, fileMask: string; SubDirsAllow: Boolean): Extended;
var
	FSR, DSR: TFindRec; FindResult: Boolean; APath: string;
Begin
APath:= AddBackslash(fromDir);
FindResult:= FindFirst(APath + fileMask, FSR);
Try
while FindResult do
begin
if FSR.Attributes and FILE_ATTRIBUTE_DIRECTORY = 0 then Result:= Result + Size64(FSR.SizeHigh, FSR.SizeLow)
    KeyPress(VK_ESCAPE, EscFlag);
    if EscFlag then Exit else FindResult:= FindNext(FSR);
FindResult:= FindNext(FSR);
end;
FindResult := FindFirst(APath + '*.*', DSR);
while FindResult and SubDirsAllow do
begin
if ((DSR.Attributes and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY) and not ((DSR.Name = '.') or (DSR.Name = '..')) then
{Recursion} Result:= Result + CalcDirSize(APath + DSR.Name, fileMask, SubDirsAllow);
FindResult:= FindNext(DSR);
end;
Finally
FindClose(FSR); FindClose(DSR);
end;
End;

Procedure SizeButtonOnClick(Sender: TObject); var res: Extended;
Begin
LSize.Caption:= 'Please wait...' #13#10 'Calculating folders'; WizardForm.Repaint
EscFlag:= false; //       CalcDirSize.
SizeButton.Caption:= 'Esc'; // NEW
res:= CalcDirSize(Folder, '*', True); //   (   SHFileOperation)  ,      
LSize.Caption:= 'DirSize = ' + ByteOrGB(res, true) + #13#10 + Folder;
SizeButton.Caption := 'Calc';
End;

Procedure BrowseOnClick(Sender: TObject);
Begin
if BrowseForFolder('Calc Folder', Folder, false) then SizeButtonOnClick(SizeButton);
End;

Procedure InitializeWizard;
begin
Browse:= TButton.Create(WizardForm);
Browse.SetBounds(WizardForm.ClientWidth - WizardForm.CancelButton.Left - WizardForm.CancelButton.Width, WizardForm.CancelButton.Top, 48, WizardForm.CancelButton.Height)
Browse.Caption := 'Change';
Browse.OnClick := @BrowseOnClick;
Browse.Parent := WizardForm;

SizeButton:= TButton.Create(WizardForm);
SizeButton.SetBounds(Browse.Left + Browse.Width, WizardForm.CancelButton.Top, WizardForm.CancelButton.Width/2, WizardForm.CancelButton.Height)
SizeButton.Caption := 'Calc';
SizeButton.OnClick := @SizeButtonOnClick;
SizeButton.Parent := WizardForm;

Folder:= ExpandConstant('C:\') //     

LSize:= TLabel.Create(WizardForm);
LSize.SetBounds(SizeButton.Left + SizeButton.Width + 8, SizeButton.Top, 12, 12)
LSize.Caption:= 'Click Calc button' #13#10 'Current dir: ' + Folder;
LSize.Parent:= WizardForm;

//    :  ,   ,      .
//       ,      ,   ...

//          ,     .   , ..      .

HintForm:= CreateCustomForm;    //    Access violation at address 00446552. Read of address 000002B6.
HintPanel:= TPanel.Create(WizardForm)    //    Access violation at address 00446552. Read of address 000002B6.

end;


