#define	BeginColor	170*65536 + 148*256 + 70	;Blue Green Red
#define	FinishColor	180*65536 + 224*256 + 230

[Setup]
AppName=Gradient
AppVerName=Gradient
CreateAppDir=false
OutputDir=.

[Code]
type	hDC = Longint; TSize = record cx: UINT; cy: UINT; end;
var BackgroundForm: TForm; BackgroundImage: TBitmapImage; i, n: Integer;
const SRCCOPY = $CC0020;

function ShowWindow(hWnd, nCmdShow: LongWord): LongWord; external 'ShowWindow@user32';
function MulDiv(Number, Numerator, Denominator: Integer): Integer; external 'MulDiv@kernel32';	//	 Numerator  Number   p  Denominator, p     .  32767  -32767,  p  Denominator p .
function SetBkMode(DC: hDC; BkMode: Integer): Integer; external 'SetBkMode@gdi32';

Function RGB(r, g, b: Longint): Longint; Begin Result:= (r or (g shl 8) or (b shl 16)) End;
Function GetBValue(rgb: DWord): Byte; Begin Result:= Byte(rgb shr 16) End;
Function GetGValue(rgb: DWord): Byte; Begin Result:= Byte(rgb shr 8) End;
Function GetRValue(rgb: DWord): Byte; Begin Result:= Byte(rgb) End;

Procedure GradientFill(WorkBmp: TBitmapImage; BeginColor, FinishColor: TColor);	var ColorBand: TRect; Begin
	WorkBmp.Bitmap.Width:= WorkBmp.Width; WorkBmp.Bitmap.Height:= WorkBmp.Height;
  n:= 255; for i:=0 to n do begin
	ColorBand.Right:= WorkBmp.Width;
	ColorBand.Top:= MulDiv(i, WorkBmp.Height, n);
	ColorBand.Bottom:= MulDiv(i+1, WorkBmp.Height, n);
	WorkBmp.Bitmap.Canvas.Brush.Color:= RGB(GetRValue(BeginColor) + MulDiv(I, GetRValue(FinishColor) - GetRValue(BeginColor), n-1), GetGValue(BeginColor) + MulDiv(I, GetGValue(FinishColor) - GetGValue(BeginColor), n-1), GetBValue(BeginColor) + MulDiv(I, GetBValue(FinishColor) - GetBValue(BeginColor), n-1));
	WorkBmp.Bitmap.Canvas.FillRect(ColorBand); end;
End;

Procedure BitmapTextOut(Bmp: TBitmapImage; Text, FontName: String; Style, Left, Top, Size: Byte; Color: TColor); Begin	{     }
  with Bmp.Bitmap.Canvas do begin
	Font.Color:= clBlack; Font.Name:= FontName;
	Case Style of 1: Font.Style:= [fsBold]; 2: Font.Style:= [fsItalic]; 3: Font.Style:= [fsBold, fsItalic]; end;
	Font.Height:= (Bmp.Width + Bmp.Height)/200 *Size	//       :(
  SetBkMode(Handle, 1);
	TextOut(Bmp.Width/100*Left, Bmp.Height/100*Top, Text);
	Font.Color:= Color;
	TextOut(Bmp.Width/100*Left - 2, Bmp.Height/100*Top - 2, Text);
  end
End;

Procedure BackgroundOnActivate(Sender: TObject); Begin if WizardForm.Visible then WizardForm.Show End;
Procedure BackgroundOnResize(Sender: TObject); Begin
	GradientFill(BackgroundImage, {#BeginColor}, {#FinishColor});
	BitmapTextOut(BackgroundImage, MainForm.Caption, 'Times', 3, 10, 8, 4, clWhite)
End;

Procedure InitializeWizard; Begin
  BackgroundForm:= TForm.Create(nil)
	BackgroundForm.BorderStyle:= bsNone
	BackgroundForm.OnActivate:= @BackgroundOnActivate;
	BackgroundForm.OnResize:= @BackgroundOnResize;
  BackgroundImage:= TBitmapImage.Create(BackgroundForm);
	BackgroundImage.Align:= alClient;	//	BackgroundImage.Enabled:= False;
	BackgroundImage.Parent:= BackgroundForm;
  ShowWindow(BackgroundForm.Handle, sw_ShowMaximized)	//     
End;

Procedure DeinitializeSetup;
Begin
	BackgroundForm.Free;
End;


