[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DirExistsWarning=no
DefaultDirName={pf}\My Program

[Code]
type
  TThreadEntry32 = record
    dwSize: DWORD;
    cntUsage: DWORD;
    th32ThreadID: DWORD;
    th32OwnerProcessID: DWORD;
    tpBasePri: Longint;
    tpDeltaPri: Longint;
    dwFlags: DWORD;
  end;

  TGUIThreadinfo = record
    cbSize: DWORD;
    flags: DWORD;
    hwndActive: HWND;
    hwndFocus: HWND;
    hwndCapture: HWND;
    hwndMenuOwner: HWND;
    hwndMoveSize: HWND;
    hwndCaret: HWND;
    rcCaret: TRect;
  end;

  TMsg = record
    hwnd: HWND;
    message: UINT;
    wParam: Longint;
    lParam: Longint;
    time: DWORD;
    pt: TPoint;
  end;

  TProcessEntry32 = record
    dwSize: DWORD;
    cntUsage: DWORD;
    th32ProcessID: DWORD;
    th32DefaultHeapID: DWORD;
    th32ModuleID: DWORD;
    cntThreads: DWORD;
    th32ParentProcessID: DWORD;
    pcPriClassBase: Longint;
    dwFlags: DWORD;
    szExeFile: array[0..259] of Char;
  end;

const
  PM_REMOVE      = 1;
  HWND_TOP       = 0;
  SWP_NOSIZE     = 1;
  SWP_SHOWWINDOW = $40;
  STATUS_WAIT_0  = $00000000;
  WAIT_OBJECT_0  = ((STATUS_WAIT_0)+0);

function CreateToolhelp32Snapshot(dwFlags, th32ProcessID: DWORD): THandle; external 'CreateToolhelp32Snapshot@kernel32.dll stdcall';

function Thread32First(hSnapshot: THandle; var lpte: TThreadEntry32): BOOL; external 'Thread32First@kernel32.dll stdcall';
function Thread32Next(hSnapshot: THandle; var lpte: TThreadEntry32): BOOL; external 'Thread32Next@kernel32.dll stdcall';

function Process32First(hSnapshot: THandle; var lppe: TProcessEntry32): BOOL; external 'Process32First@kernel32.dll stdcall';
function Process32Next(hSnapshot: THandle; var lppe: TProcessEntry32): BOOL; external 'Process32Next@kernel32.dll stdcall';
function OpenProcess(dwDesiredAccess: DWORD; bInheritHandle: BOOL; dwProcessId: DWORD): THandle; external 'OpenProcess@kernel32.dll stdcall';

function GetGUIThreadInfo (idThread: DWORD; var pgui: TGUIThreadinfo): BOOL; external 'GetGUIThreadInfo@user32.dll stdcall';

function CloseHandle(hObject: THandle): BOOL; external 'CloseHandle@kernel32.dll stdcall';

function SetWindowPos(hWnd, hWndInsertAfter, X, Y, cx, cy, wFlags: Longint):boolean; external 'SetWindowPos@user32.dll stdcall';

function WaitForInputIdle(hProcess: THandle; dwMilliseconds: DWORD): DWORD; external 'WaitForInputIdle@user32.dll stdcall';
function WaitForSingleObject(hHandle: THandle; dwMilliseconds: DWORD): DWORD; external 'WaitForSingleObject@kernel32.dll stdcall';

function PeekMessage(var lpMsg: TMsg; hWnd: HWND; wMsgFilterMin, wMsgFilterMax, wRemoveMsg: UINT): BOOL; external 'PeekMessageA@user32.dll stdcall';
function TranslateMessage(const lpMsg: TMsg): BOOL; external 'TranslateMessage@user32.dll stdcall';
function DispatchMessage(const lpMsg: TMsg): Longint; external 'DispatchMessageA@user32.dll stdcall';

procedure AppProcessMessage;
var
  Msg: TMsg;
begin
  while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
  end;
end;

procedure GetProcessParam(const FileName:string; var PHandle:THandle; var PID:Cardinal);
var
  h:THandle;
  PS:TProcessEntry32;
  fn:string;
  i:integer;
begin
  h:=CreateToolHelp32Snapshot($00000002,0);
  if h=0 then Exit;
  PS.dwSize:=SizeOf(PS);
  if Process32First(h,PS) then
    repeat
      fn:='';  //,  -  
      for i:=0 to 254 do begin
        if PS.szExeFile[i]=#0 then Break;
        fn:=fn+PS.szExeFile[i];
      end;
      if AnsiUpperCase(fn)=AnsiUpperCase(FileName) then begin
        PID:=PS.th32ProcessID;
        Break;
      end;
    until not Process32Next(h,PS);
  CloseHandle(h);
  PHandle:=OpenProcess($001F0FFF,False,PID);
end;

procedure GetWndHandle(PID:Cardinal; var hWnd:HWND);
var
  hSnapshot:THandle;
  lppe:TThreadEntry32;
  GUIThreadInfo:TGUIThreadInfo;
begin
  hSnapshot:=CreateToolhelp32Snapshot($00000004,0);
  if hSnapshot=0 then Exit;
  lppe.dwSize:=SizeOf(lppe);
  GUIThreadinfo.cbSize:=SizeOf(GUIThreadinfo);
  if Thread32First(hSnapshot,lppe) then
    repeat
      if PID=lppe.th32OwnerProcessID then
        if GetGUIThreadInfo(lppe.th32ThreadID,GUIThreadInfo) then
            if (GUIThreadInfo.hwndActive>0) then begin
              hWnd:=GUIThreadInfo.hwndActive;
              Break;
            end;
    until not Thread32Next(hSnapshot,lppe);
  CloseHandle(hSnapshot);
end;

procedure ExecAppAndMoveWindow(Filename,Params,WorkingDir:string;X,Y:integer;WaitingProcess:boolean);
var
  ErrorCode: Integer;
  PID:Cardinal;
  PH:THandle;
  PWndHandle:HWND;
begin
  //   SW_HIDE  ,   ,  ,    
  if not ShellExec('',Filename,Params,WorkingDir,SW_SHOW,ewNoWait,ErrorCode) then Exit;
  GetProcessParam('notepad.exe',PH,PID);
  if PID<>0 then begin
    if PH<>0 then WaitForInputIdle(PH,DWORD($FFFFFFFF));
    //    EnumThreadWindows (     SW_HIDE  ShellExec     ),
    //     innocallback.dll,   -
    GetWndHandle(PID,PWndHandle);
    if PWndHandle<>0 then SetWindowPos(PWndHandle,HWND_TOP,X,Y,0,0,SWP_NOSIZE or SWP_SHOWWINDOW);
    if WaitingProcess and (PH<>0) then
      while WaitForSingleObject(PH,200)<>WAIT_OBJECT_0 do AppProcessMessage;
  end;
  CloseHandle(PH);
end;

procedure InitializeWizard();
begin
  // -     ,    ,    -  
  //  -   .       innocallback.dll
  ExecAppAndMoveWindow('notepad.exe','C:\AUTOEXEC.BAT','',250,250,True);
end;
