[Setup]
AppName=My Program
AppVerName=My Program ver.1.5
DefaultDirName={pf}\My Program

[Code]
//    (IconCache.db) 

procedure DeinitializeUninstall;
Var OldString:String;
begin
RegQueryMultiStringValue(HKLM,'SYSTEM\CurrentControlSet\Control\Session Manager','PendingFileRenameOperations',OldString);
If (OldString<>'') Then OldString:=OldString+#0;
RegWriteMultiStringValue(HKLM,'SYSTEM\CurrentControlSet\Control\Session Manager','PendingFileRenameOperations',OldString+'\??\'+ExpandConstant('{localappdata}')+'\IconCache.db'+#0+#0);
end;

//   

const
  BASS_MUSIC_RAMP         = 1;      // normal ramping (only for Fast Tracker .xm)
  BASS_MUSIC_RAMPS        = 2;      // sensitive ramping (only for Fast Tracker .xm)
  BASS_MUSIC_LOOP         = 4;      // loop music
  BASS_MUSIC_FT2MOD       = 16;     // play .MOD as FastTracker 2 does
  BASS_MUSIC_PT1MOD       = 32;     // play .MOD as ProTracker 1 does
  BASS_MUSIC_SURROUND	  = 512;    // surround sound
  BASS_MUSIC_SURROUND2	  = 1024;   // surround sound (mode 2)


                                         //
  AW_FADE_IN = $00080000;
  AW_FADE_OUT = $00090000;
  AW_SLIDE_IN_LEFT = $00040001;
  AW_SLIDE_OUT_LEFT = $00050002;
  AW_SLIDE_IN_RIGHT = $00040002;
  AW_SLIDE_OUT_RIGHT = $00050001;
  AW_SLIDE_IN_TOP = $00040004;
  AW_SLIDE_OUT_TOP = $00050008;
  AW_SLIDE_IN_BOTTOM = $00040008;
  AW_SLIDE_OUT_BOTTOM = $00050004;
  AW_DIAG_SLIDE_IN_TOPLEFT = $00040005;
  AW_DIAG_SLIDE_OUT_TOPLEFT = $0005000a;
  AW_DIAG_SLIDE_IN_TOPRIGHT = $00040006;
  AW_DIAG_SLIDE_OUT_TOPRIGHT = $00050009;
  AW_DIAG_SLIDE_IN_BOTTOMLEFT = $00040009;
  AW_DIAG_SLIDE_OUT_BOTTOMLEFT = $00050006;
  AW_DIAG_SLIDE_IN_BOTTOMRIGHT = $0004000a;
  AW_DIAG_SLIDE_OUT_BOTTOMRIGHT = $00050005;
  AW_EXPLODE = $00040010;
  AW_IMPLODE = $00050010;

function AnimateWindow(hWnd: HWND; dwTime: DWORD; dwFlags: DWORD): Boolean;
external 'AnimateWindow@user32 stdcall';

procedure OnShow(Sender: TObject);
begin
 WizardForm.Center;
 AnimateWindow(WizardForm.Handle,1000,AW_EXPLODE);
 WizardForm.NextButton.OnClick(WizardForm.NextButton);
 WizardForm.BackButton.OnClick(WizardForm.BackButton);
end;
//

var
  PlayButton, PauseButton, StopButton: TPanel;
  PlayImage, PauseImage, StopImage: TBitmapImage;
  PlayLabel, PauseLabel, StopLabel: TLabel;

function BASSMOD_Init(device: Integer; freq, flags: DWORD): Boolean;
external 'BASSMOD_Init@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_MusicFree();
external 'BASSMOD_MusicFree@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicLoad(mem: BOOL; f: PChar; offset: DWORD; length: DWORD; flags: DWORD): Boolean;
external 'BASSMOD_MusicLoad@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPlay(): Boolean;
external 'BASSMOD_MusicPlay@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicGetPosition(): Boolean;
external 'BASSMOD_MusicGetPosition@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicStop(): Boolean;
external 'BASSMOD_MusicStop@files:BASSMOD.dll stdcall delayload';

function BASSMOD_MusicPause(): Boolean;
external 'BASSMOD_MusicPause@files:BASSMOD.dll stdcall delayload';

procedure BASSMOD_Free();
external 'BASSMOD_Free@files:BASSMOD.dll stdcall delayload';

procedure PlayButtonOnClick(Sender: TObject);
var
  Name1: string;
begin
if not BASSMOD_MusicPlay then
 begin
   Name1:=ExpandConstant('{tmp}\music.xm');
 if BASSMOD_MusicLoad(FALSE, PChar(Name1), 0, 0, 4 or 512 or 32 or 1) then
  BASSMOD_MusicPlay;
end;
end;

procedure PauseButtonOnClick(Sender: TObject);
begin
 BASSMOD_MusicPause;
end;

procedure StopButtonOnClick(Sender: TObject);
begin
 BASSMOD_MusicStop;
 BASSMOD_MusicFree;
end;
                                                                             //Buttons Image OnClick

procedure PlayMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if PlayLabel.Enabled then
     PlayImage.Left:=-90
end;

procedure PlayMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PlayImage.Left:=0
end;

procedure PauseMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if PauseLabel.Enabled then
     PauseImage.Left:=-120
end;

procedure PauseMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  PauseImage.Left:=-30
end;

procedure StopMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if StopLabel.Enabled then
     StopImage.Left:=-150
end;

procedure StopMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  StopImage.Left:=-60
end;
//

procedure BevelLabelClick(Sender: TObject);                                  //  
var
ErrorCode: Integer;
begin
ShellExec('open','http://forum.oszone.net/member-29707.html','', '', SW_SHOW, ewNoWait, ErrorCode)
end;
//

procedure InitializeWizard();
var
  Music: String;                                                             // MUSIC=NO
  License: string;                                                           //  RTF
  Name1: string;
  Text: TNewStaticText;
begin
with WizardForm do begin                                                     //  
  with BeveledLabel do begin
    OnClick:=@BevelLabelClick;
    Font.Color:=clBlue;
    Enabled:=True;
    Cursor:=crHand;
    OnShow:=@OnShow;
    Center;                                                          //
  end;
end;

Music:=ExpandConstant('{param:Music|yes}');                                  // MUSIC=NO
if Music='yes' then                                                          // MUSIC=NO
  begin
  ExtractTemporaryFile(ExpandConstant('BASSMOD.dll'));
  ExtractTemporaryFile(ExpandConstant('music.xm'));
  if not BASSMOD_Init(-1,44100,0) then begin
  MsgBox('BASSMOD   ,   .', mbInformation, MB_OK)
  BASSMOD_Free;
  end
  Name1:=ExpandConstant('{tmp}\music.xm');
  BASSMOD_MusicFree;
  if BASSMOD_MusicLoad(FALSE, PChar(Name1), 0, 0, BASS_MUSIC_LOOP or BASS_MUSIC_SURROUND) then
  BASSMOD_MusicPlay;

  ExtractTemporaryFile('MusicButton.bmp')
                                                                             //PLAY BUTTON
  PlayButton:=TPanel.Create(WizardForm)
  PlayButton.Left:=33
  PlayButton.Top:=466
  PlayButton.Width:=30
  PlayButton.Height:=20
  PlayButton.Cursor:=crHand
  PlayButton.ShowHint:=True
  PlayButton.Hint:=' '
  PlayButton.OnClick:=@PlayButtonOnClick
  PlayButton.Parent:=WizardForm

  PlayImage:=TBitmapImage.Create(WizardForm)
  PlayImage.Left:=0
  PlayImage.Top:=0
  PlayImage.Width:=180
  PlayImage.Height:=20
  PlayImage.Enabled:=False
  PlayImage.Bitmap.LoadFromFile(ExpandConstant('{tmp}\MusicButton.bmp'))
  PlayImage.Parent:=PlayButton

  PlayLabel:=TLabel.Create(WizardForm)
  PlayLabel.Width:=PlayButton.Width
  PlayLabel.Height:=PlayButton.Height
  PlayLabel.Autosize:=False
  PlayLabel.Transparent:=True
  PlayLabel.OnClick:=@PlayButtonOnClick
  PlayLabel.OnMouseDown:=@PlayMouseDown
  PlayLabel.OnMouseUp:=@PlayMouseUp
  PlayLabel.Parent:=PlayButton
                                                                             //PAUSE BUTTON
  PauseButton:=TPanel.Create(WizardForm)
  PauseButton.Left:=67
  PauseButton.Top:=466
  PauseButton.Width:=30
  PauseButton.Height:=20
  PauseButton.Cursor:=crHand
  PauseButton.ShowHint:=True
  PauseButton.Hint:=' '
  PauseButton.OnClick:=@PauseButtonOnClick
  PauseButton.Parent:=WizardForm

  PauseImage:=TBitmapImage.Create(WizardForm)
  PauseImage.Left:=-30
  PauseImage.Top:=0
  PauseImage.Width:=180
  PauseImage.Height:=20
  PauseImage.Enabled:=False
  PauseImage.Bitmap.LoadFromFile(ExpandConstant('{tmp}\MusicButton.bmp'))
  PauseImage.Parent:=PauseButton

  PauseLabel:=TLabel.Create(WizardForm)
  PauseLabel.Width:=PauseButton.Width
  PauseLabel.Height:=PauseButton.Height
  PauseLabel.Autosize:=False
  PauseLabel.Transparent:=True
  PauseLabel.OnClick:=@PauseButtonOnClick
  PauseLabel.OnMouseDown:=@PauseMouseDown
  PauseLabel.OnMouseUp:=@PauseMouseUp
  PauseLabel.Parent:=PauseButton
                                                                             //STOP BUTTON
  StopButton:=TPanel.Create(WizardForm)
  StopButton.Left:=101
  StopButton.Top:=466
  StopButton.Width:=30
  StopButton.Height:=20
  StopButton.Cursor:=crHand
  StopButton.ShowHint:=True
  StopButton.Hint:=' '
  StopButton.OnClick:=@StopButtonOnClick
  StopButton.Parent:=WizardForm

  StopImage:=TBitmapImage.Create(WizardForm)
  StopImage.Left:=-60
  StopImage.Top:=0
  StopImage.Width:=180
  StopImage.Height:=20
  StopImage.Enabled:=False
  StopImage.Bitmap.LoadFromFile(ExpandConstant('{tmp}\MusicButton.bmp'))
  StopImage.Parent:=StopButton

  StopLabel:=TLabel.Create(WizardForm)
  StopLabel.Width:=StopButton.Width
  StopLabel.Height:=StopButton.Height
  StopLabel.Autosize:=False
  StopLabel.Transparent:=True
  StopLabel.OnClick:=@StopButtonOnClick
  StopLabel.OnMouseDown:=@StopMouseDown
  StopLabel.OnMouseUp:=@StopMouseUp
  StopLabel.Parent:=StopButton
end;

//    

ExtractTemporaryFile('rtf.rtf')                                              //  RTF
  LoadStringFromFile(ExpandConstant('{tmp}') + '\rtf.rtf', License)          //  RTF
begin
with WizardForm do begin
  Position:=poScreenCenter
  ClientWidth:=690
  ClientHeight:=496
  Font.Color:=15389620
  Font.Name:='MS Sans Serif'
  Font.Style:=[]
  with Bevel do begin
    Left:=0
    Top:=313
    Width:=497
    Height:=2
    Visible:=False
  end
  with CancelButton do begin
    Left:=580
    Top:=464
    Width:=90
    Height:=25
    BringToFront
  end
  with NextButton do begin
    Left:=430
    Top:=464
    Width:=90
    Height:=25
    BringToFront
  end
  with BackButton do begin
    Left:=330
    Top:=464
    Width:=90
    Height:=25
    BringToFront
  end
  with OuterNotebook do begin
    Left:=0
    Top:=0
    Width:=690
    Height:=496
    with WelcomePage do begin
      Color:=7891286
      with WizardBitmapImage do begin
        Left:=0
        Top:=0
        Width:=690
        Height:=496
      end
      with WelcomeLabel2 do begin
        Left:=205
        Top:=230
        Width:=465
        Height:=200
      end
      with WelcomeLabel1 do begin
        Left:=205
        Top:=190
        Width:=465
        Height:=28
        Font.Color:=15389620
        Font.Size:=8
      end
    end
    with InnerPage do begin
      with Bevel1 do begin
        Left:=0
        Top:=58
        Width:=499
        Height:=3
        Visible:=False
      end
      with InnerNotebook do begin
        Left:=205
        Top:=79
        Width:=465
        Height:=354
        BringToFront
        Color:=7891286
        with LicensePage do begin
          with LicenseNotAcceptedRadio do begin
            Left:=0
            Top:=338
            Width:=465
            Height:=17
            Checked:=True
          end
          with LicenseAcceptedRadio do begin
            Left:=0
            Top:=318
            Width:=465
            Height:=17
          end
          with LicenseMemo do begin
            Left:=0
            Top:=38
            Width:=465
            Height:=266
            ReadOnly:=True
            ScrollBars:=ssVertical
          end
          with LicenseLabel1 do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with PasswordPage do begin
          with PasswordEdit do begin
            Left:=0
            Top:=50
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with PasswordEditLabel do begin
            Left:=0
            Top:=34
            Width:=465
            Height:=14
          end
          with PasswordLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with InfoBeforePage do begin
          with InfoBeforeMemo do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=327
            ScrollBars:=ssVertical
            RTFText:=License                                                 //  RTF
          end
          with InfoBeforeClickLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with UserInfoPage do begin
          with UserInfoSerialEdit do begin
            Left:=0
            Top:=120
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with UserInfoSerialLabel do begin
            Left:=0
            Top:=104
            Width:=465
            Height:=14
          end
          with UserInfoOrgEdit do begin
            Left:=0
            Top:=68
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with UserInfoOrgLabel do begin
            Left:=0
            Top:=52
            Width:=465
            Height:=14
          end
          with UserInfoNameEdit do begin
            Left:=0
            Top:=16
            Width:=465
            Height:=21
            Font.Color:=clWindowText
          end
          with UserInfoNameLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectDirPage do begin
          with SelectDirBitmapImage do begin
            Left:=0
            Top:=0
            Width:=32
            Height:=32
            Visible:=False
          end
          with DiskSpaceLabel do begin
            Left:=0
            Top:=340
            Width:=465
            Height:=14
          end
          with DirBrowseButton do begin
            Left:=375
            Top:=288
            Width:=90
            Height:=25
          end
          with DirEdit do begin
            Left:=0
            Top:=290
            Width:=365
            Height:=21
            Font.Color:=clWindowText
          end
          with SelectDirBrowseLabel do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=28
          end
          with SelectDirLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectComponentsPage do begin
          with ComponentsDiskSpaceLabel do begin
            Left:=0
            Top:=340
            Width:=417
            Height:=14
          end
          with ComponentsList do begin
            Left:=0
            Top:=48
            Width:=465
            Height:=275
            Font.Color:=15389620
            Color:=7891286
          end
          with TypesCombo do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=21
            Font.Color:=15389620
            Color:=7891286
           end
          with SelectComponentsLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectProgramGroupPage do begin
          with SelectGroupBitmapImage do begin
            Left:=0
            Top:=0
            Width:=32
            Height:=32
            Visible:=False
          end
          with NoIconsCheck do begin
            Left:=0
            Top:=337
            Width:=465
            Height:=17
          end
          with GroupBrowseButton do begin
            Left:=375
            Top:=288
            Width:=90
            Height:=25
          end
          with GroupEdit do begin
            Left:=0
            Top:=290
            Width:=365
            Height:=21
            Font.Color:=clWindowText
          end
          with SelectStartMenuFolderBrowseLabel do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=28
          end
          with SelectStartMenuFolderLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
        with SelectTasksPage do begin
          with TasksList do begin
            Left:=0
            Top:=34
            Width:=465
            Height:=317
            Color:=7891286
          end
          with SelectTasksLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with ReadyPage do begin
          with ReadyMemo do begin
            Left:=0
            Top:=34
            Width:=465
            Height:=317
            Color:=7891286
          end
          with ReadyLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=28
          end
        end
        with PreparingPage do begin
          with PreparingErrorBitmapImage do begin
            Left:=0
            Top:=0
            Width:=16
            Height:=16
            Visible:=False
          end
          with PreparingLabel do begin
            Left:=24
            Top:=0
            Width:=393
            Height:=14
            Visible:=False
          end
        end
        with InstallingPage do begin
          with FilenameLabel do begin
            Left:=0
            Top:=16
            Width:=465
            Height:=16
          end
          with StatusLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=16
          end
          with ProgressGauge do begin
            Left:=0
            Top:=42
            Width:=465
            Height:=21
            Min:=0
            Max:=100
          end
        end
        with InfoAfterPage do begin
          with InfoAfterMemo do begin
            Left:=0
            Top:=24
            Width:=465
            Height:=327
            ScrollBars:=ssVertical
          end
          with InfoAfterClickLabel do begin
            Left:=0
            Top:=0
            Width:=465
            Height:=14
          end
        end
      end
      with MainPanel do begin
        Left:=0
        Top:=0
        Width:=690
        Height:=496
        Color:=clWindow
        with WizardSmallBitmapImage do begin
          Left:=0
          Top:=0
          Width:=690
          Height:=496
          BackColor:=clWindow
        end
        with PageDescriptionLabel do begin
          Left:=25
          Top:=25
          Width:=500
          Height:=14
          Color:=9208939
          Font.Color:=15389620
        end
        with PageNameLabel do begin
          Left:=15
          Top:=7
          Width:=500
          Height:=14
          Color:=9208939
          Font.Color:=15389620
        end
      end
    end
    with FinishedPage do begin
      Color:=7891286
      with WizardBitmapImage2 do begin
        Left:=0
        Top:=0
        Width:=690
        Height:=496
      end
      with NoRadio do begin
        Left:=205
        Top:=227
        Width:=465
        Height:=17
      end
      with YesRadio do begin
        Left:=205
        Top:=199
        Width:=465
        Height:=17
      end
      with RunList do begin
        Left:=205
        Top:=199
        Width:=465
        Height:=149
        BorderStyle:=bsNone
      end
      with FinishedLabel do begin
        Left:=205
        Top:=119
        Width:=465
        Height:=53
      end
      with FinishedHeadingLabel do begin
        Left:=205
        Top:=79
        Width:=465
        Height:=24
        Font.Color:=15389620
        Font.Size:=8
      end
    end
  end
  with BeveledLabel do begin
    Left:=555
    Top:=40
    Width:=150
    Height:=18
    Enabled:=True
    Color:=9208939
    Font.Color:=8388608
    Font.Size:=8
  end
end
end;
end;

procedure CancelButtonClick(CurPageID: Integer; var Cancel, Confirm: Boolean);
begin
Confirm:=False;
AnimateWindow(WizardForm.Handle,1000,AW_IMPLODE);
Cancel:=True;
end;
[Files]
Source: ..\music.xm; DestDir: {app}
Source: ..\bassmod.dll; DestDir: {app}
Source: ..\MusicButton.bmp; DestDir: {app}
Source: ..\rtf.rtf; DestDir: {app}
