[Setup]
AppName=MyProg
AppVerName=MyProg 1.0
DefaultDirName={pf}\MyProg
DefaultGroupName=MyProg
AllowNoIcons=yes
OutputBaseFilename=MyProg
ShowLanguageDialog=True

[Languages]
Name: english; MessagesFile: compiler:Default.isl
Name: russian; MessagesFile: compiler:Languages\Russian.isl

[Files]
Source: compiler:license.txt; DestDir: {app}; DestName: MyProg.exe; Check: english
Source: compiler:license.txt; DestDir: {app}; DestName: MyProg.exe; Check: russian

[Icons]
Name: {group}\MyProg; Filename: {app}\MyProg.exe; WorkingDir: {app}
Name: {group}\Uninstall MyProg; Filename: {uninstallexe}; WorkingDir: {app}

[Code]
var
  RadioButton1, RadioButton2: TNewRadioButton;

function russian: Boolean;
begin
  Result := RadioButton1.Checked;
end;

function english: Boolean;
begin
  Result := RadioButton2.Checked;
end;

procedure InitializeWizard();
var
  MsgStr: TNewStaticText;
begin
  MsgStr := TNewStaticText.Create(WizardForm);
  with MsgStr do
  begin
    Top := ScaleY(130);
    Left := ScaleX(3);
    Width := ScaleX(400);
    AutoSize := False;
    Caption := '     MyProg:';
    Parent := WizardForm.SelectDirPage;
  end;

  RadioButton1 := TNewRadioButton.Create(WizardForm);
  with RadioButton1 do
  begin
    Top := ScaleY(150);
    Left := ScaleX(10);
    Width := ScaleX(300);
    Caption := '';
    Parent := WizardForm.SelectDirPage;
  end;

  RadioButton2 := TNewRadioButton.Create(WizardForm);
  with RadioButton2 do
  begin
    Top := ScaleY(170);
    Left := ScaleX(10);
    Width := ScaleX(300);
    Caption := '';
    Parent := WizardForm.SelectDirPage;
  end;

  if ActiveLanguage = 'russian' then
  begin
    RadioButton1.Checked := True;
  end else
  begin
    RadioButton2.Checked := True;
  end;
end;

function UpdateReadyMemo(Space, NewLine, MemoUserInfoInfo, MemoDirInfo, MemoTypeInfo,
  MemoComponentsInfo, MemoGroupInfo, MemoTasksInfo: String): String;
var
  S: String;
begin
  S := S + MemoDirInfo + NewLine + NewLine;

  S := S + '     MyProg:' + NewLine;
  if RadioButton1.Checked then
  begin
    S := S + Space + '' + NewLine + NewLine;
  end else
  begin
    S := S + Space + '' + NewLine + NewLine;
  end;

  if (WizardForm.NoIconsCheck.Checked) = False then
  begin
    S := S + MemoGroupInfo + NewLine + NewLine;
  end;

  Result := S;
end;

