[Setup]
AppName=My Program
AppVerName=My Program v.1.2
DefaultDirName={pf}\My Program

[Types]
Name: "full"; Description: "Full installation"
Name: "compact"; Description: "Compact installation"
Name: "custom"; Description: "Custom installation"; Flags: iscustom

[Components]
Name: "program"; Description: "Program Files"; Types: full compact custom; Flags: fixed
Name: "help"; Description: "Help File"; Types: full
Name: "readme"; Description: "Readme File"; Types: full
Name: "readme\en"; Description: "English"; Flags: exclusive
Name: "readme\de"; Description: "German"; Flags: exclusive

[Code]
var
  Page: TInputQueryWizardPage;
  UserName, UserPass: String;

procedure InitializeWizard();
begin
  Page := CreateInputQueryPage(wpSelectComponents,
      'Personal Information', 'Who are you?',
      'Please specify your name and password, then click Next.');
  Page.Add('Name:', False);
  Page.Add('Password:', True);
  Page.Values[0] := ExpandConstant('{sysuserinfoname}');
end;

function NextButtonClick(CurPageID: Integer): Boolean;
begin
  if CurPageID = Page.ID then
    begin
      if (Page.Values[0] <> '') and
         (Page.Values[1] <> '') then
         begin
           UserName:= Page.Values[0];
           UserPass:= Page.Values[1];
           Result:= True;
         end;
    end
  else Result:= True;
end;

function ShouldSkipPage(PageID: Integer): Boolean;
begin
  if (PageID = Page.ID) and Not IsComponentSelected('help') then
    Result:= True;
end;
