[Setup]
AppName=Example.Mini.Progress.Bar
AppVerName=Example.Mini.Progress.Bar 1.5
DefaultDirName={pf}\Example.Mini.Progress.Bar
OutputBaseFilename=mini.progress.bar.by.genri
WindowVisible=no

[Languages]
Name: russian; MessagesFile: compiler:Languages\Russian.isl

[Files]
Source: compiler:WizModernSmallImage.bmp; Flags: dontcopy nocompression

[Code]
function GetSystemMetrics(nIndex: Integer): Integer; external 'GetSystemMetrics@user32.dll stdcall';

procedure InitializeWizard();
var
  Form: TSetupForm;
  ProgressBar: TNewProgressBar;
  CancelButton: TButton;
  StaticText: TNewStaticText;
  BitmapImage: TBitmapImage;
  BitmapFileName: string;
  i: Integer;
begin
  Form := CreateCustomForm();
  try
    with Form do
    begin
      ClientWidth := ScaleX(375); //   ProgressBar
      ClientHeight := ScaleY(120); //   ProgressBar
      BorderStyle := bsDialog;
      Left := GetSystemMetrics(16) - ClientWidth - ScaleX(5);
      Top := GetSystemMetrics(17) - ClientHeight - ScaleY(5);
      Caption := 'Inno Setup Wizard' //  ProgressBar'a
    end;

    BitmapFileName := ExpandConstant('{tmp}\WizModernSmallImage.bmp');
    ExtractTemporaryFile(ExtractFileName(BitmapFileName));
    BitmapImage := TBitmapImage.Create(Form);
    BitmapImage.Left := ScaleX(8);
    BitmapImage.Top := ScaleY(8);
    BitmapImage.Width := ScaleX(58);
    BitmapImage.Height := ScaleY(58);
    BitmapImage.Bitmap.LoadFromFile(BitmapFileName);
    BitmapImage.Parent := Form;

    StaticText := TNewStaticText.Create(Form);
    StaticText.Top := BitmapImage.Top;
    StaticText.Left := BitmapImage.Left + BitmapImage.Width + ScaleX(8)
      StaticText.Caption := '    S.T.A.L.K.E.R.: Shadow Of' + #10#13 + 'Chernobyl' + #10#13#10 + ' ...'; //   ProgressBar'a
    StaticText.AutoSize := True;
    StaticText.Parent := Form;

    CancelButton := TButton.Create(Form);
    CancelButton.Parent := Form;
    CancelButton.Width := ScaleX(75);
    CancelButton.Height := ScaleY(23);
    CancelButton.Left := Form.ClientWidth - ScaleX(75 + 10);
    CancelButton.Top := Form.ClientHeight - ScaleY(23 + 10);
    CancelButton.Caption := 'Cancel';
    CancelButton.ModalResult := mrCancel;
    CancelButton.Cancel := True;

    ProgressBar := TNewProgressBar.Create(Form);
    with ProgressBar do
    begin
      Height := CancelButton.Height - ScaleY(8);
      Width := Form.Width - ScaleX(128);
      Top := CancelButton.Top;
      Left := BitmapImage.Left;
      Parent := Form;
      Min := 0;
      Max := 30;
      Position := 0;
    end;
    Form.ActiveControl := CancelButton;
    Form.Show();
    for i := 0 to 30 do
    begin
      ProgressBar.Position := i;
      Form.Repaint;
      Sleep(500);
      i := i + 1;
    end;
  finally
    Form.Free();
  end;
end;
