[Code]
type
  TCWPSTRUCT = record
    lParam: LongWord;
    wParam: Word;
    msg:    LongWord;
    hwnd:   HWND;
  end;

  TMSG = record
    hwnd:    HWND;
    msg:     LongWord;
    wParam:  Word;
    lParam:  LongWord;
    MsgTime: LongWord;
    pt:      TPOINT;
  end;

  TKBHookProc    = procedure(Code: Integer; wParam: Word; lParam: LongWord);
  TCWPSTRUCTProc = procedure(Code: Integer; wParam: Word; lParam: TCWPSTRUCT);
  TGETMSGProc       = procedure(Code: Integer; wParam: Word; lParam: TMSG);

const
  { SetWindowsHook() codes }
  WH_MIN             = -1;
  WH_MSGFILTER       = -1;
  WH_JOURNALRECORD   =  0; { Global ONLY }
  WH_JOURNALPLAYBACK =  1; { Global ONLY }
  WH_KEYBOARD        =  2;
  WH_GETMESSAGE      =  3;
  WH_CALLWNDPROC     =  4;
  WH_CBT             =  5;
  WH_SYSMSGFILTER    =  6;
  WH_MOUSE           =  7;
  WH_HARDWARE        =  8; { NOT Realized in Win32 }
  WH_DEBUG           =  9;
  WH_SHELL           = 10;
  WH_FOREGROUNDIDLE  = 11;
  WH_CALLWNDPROCRET  = 12;
  WH_MAX             = 12;
  WH_MINHOOK = WH_MIN;
  WH_MAXHOOK = WH_MAX;

  { Hook Codes }
  HC_ACTION      = 0;
  HC_GETNEXT     = 1;
  HC_SKIP        = 2;
  HC_NOREMOVE    = 3;
  HC_NOREM = HC_NOREMOVE;
  HC_SYSMODALON  = 4;
  HC_SYSMODALOFF = 5;

  { CBT Hook Codes }
  HCBT_MOVESIZE     = 0;
  HCBT_MINMAX       = 1;
  HCBT_QS           = 2;
  HCBT_CREATEWND    = 3;
  HCBT_DESTROYWND   = 4;
  HCBT_ACTIVATE     = 5;
  HCBT_CLICKSKIPPED = 6;
  HCBT_KEYSKIPPED   = 7;
  HCBT_SYSCOMMAND   = 8;
  HCBT_SETFOCUS     = 9;

  { WM_KEYUPDOWNCHAR HiWord(lParam) flags }
  KF_EXTENDED =  $100;
  KF_DLGMODE  =  $800;
  KF_MENUMODE = $1000;
  KF_ALTDOWN  = $2000;
  KF_REPEAT   = $4000;
  KF_UP       = $8000;

  { Window Messages }
  WM_PAINT = $000F;

  { Virtual Keys, Standard Set }
  VK_LBUTTON = 1;
  VK_RBUTTON = 2;
  VK_CANCEL = 3;
  VK_MBUTTON = 4;  { NOT contiguous with L & RBUTTON }
  VK_BACK = 8;
  VK_TAB = 9;
  VK_CLEAR = 12;
  VK_RETURN = 13;
  VK_SHIFT = $10;
  VK_CONTROL = 17;
  VK_MENU = 18;
  VK_PAUSE = 19;
  VK_CAPITAL = 20;
  VK_KANA = 21;
  VK_HANGUL = 21;
  VK_JUNJA = 23;
  VK_FINAL = 24;
  VK_HANJA = 25;
  VK_KANJI = 25;
  VK_CONVERT = 28;
  VK_NONCONVERT = 29;
  VK_ACCEPT = 30;
  VK_MODECHANGE = 31;
  VK_ESCAPE = 27;
  VK_SPACE = $20;
  VK_PRIOR = 33;
  VK_NEXT = 34;
  VK_END = 35;
  VK_HOME = 36;
  VK_LEFT = 37;
  VK_UP = 38;
  VK_RIGHT = 39;
  VK_DOWN = 40;
  VK_SELECT = 41;
  VK_PRINT = 42;
  VK_EXECUTE = 43;
  VK_SNAPSHOT = 44;
  VK_INSERT = 45;
  VK_DELETE = 46;
  VK_HELP = 47;
{ VK_0 thru VK_9 are the same as ASCII '0' thru '9' ($30 - $39) }
{ VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' ($41 - $5A) }
  VK_LWIN = 91;
  VK_RWIN = 92;
  VK_APPS = 93;
  VK_NUMPAD0 = 96;
  VK_NUMPAD1 = 97;
  VK_NUMPAD2 = 98;
  VK_NUMPAD3 = 99;
  VK_NUMPAD4 = 100;
  VK_NUMPAD5 = 101;
  VK_NUMPAD6 = 102;
  VK_NUMPAD7 = 103;
  VK_NUMPAD8 = 104;
  VK_NUMPAD9 = 105;
  VK_MULTIPLY = 106;
  VK_ADD = 107;
  VK_SEPARATOR = 108;
  VK_SUBTRACT = 109;
  VK_DECIMAL = 110;
  VK_DIVIDE = 111;
  VK_F1 = 112;
  VK_F2 = 113;
  VK_F3 = 114;
  VK_F4 = 115;
  VK_F5 = 116;
  VK_F6 = 117;
  VK_F7 = 118;
  VK_F8 = 119;
  VK_F9 = 120;
  VK_F10 = 121;
  VK_F11 = 122;
  VK_F12 = 123;
  VK_F13 = 124;
  VK_F14 = 125;
  VK_F15 = 126;
  VK_F16 = 127;
  VK_F17 = 128;
  VK_F18 = 129;
  VK_F19 = 130;
  VK_F20 = 131;
  VK_F21 = 132;
  VK_F22 = 133;
  VK_F23 = 134;
  VK_F24 = 135;
  VK_NUMLOCK = 144;
  VK_SCROLL = 145;
{ VK_L & VK_R - left and right Alt, Ctrl and Shift virtual keys.
  Used only as parameters to GetAsyncKeyState() and GetKeyState().
  No other API or message will distinguish left and right keys in this way. }
  VK_LSHIFT = 160;
  VK_RSHIFT = 161;
  VK_LCONTROL = 162;
  VK_RCONTROL = 163;
  VK_LMENU = 164;
  VK_RMENU = 165;
  VK_PROCESSKEY = 229;
  VK_ATTN = 246;
  VK_CRSEL = 247;
  VK_EXSEL = 248;
  VK_EREOF = 249;
  VK_PLAY = 250;
  VK_ZOOM = 251;
  VK_NONAME = 252;
  VK_PA1 = 253;
  VK_OEM_CLEAR = 254;

function GetKeyState(nVirtKey: integer): Shortint;
external 'GetKeyState@user32.dll stdcall';

function GetCurrentThreadId(): LongWord;
external 'GetCurrentThreadId@kernel32.dll stdcall delayload';

function SetWindowsHookEx(idHook: LongWord; callback: LongWord; hMod: LongWord; dwThreadID: HWND): LongWord;
external 'SetWindowsHookExW@user32.dll stdcall delayload';

function UnhookWindowsHookEx(idHook: LongWord): LongWord;
external 'UnhookWindowsHookEx@user32.dll stdcall delayload';

function WrapCWPSTRUCTProc(callback:TCWPSTRUCTProc; paramcount:integer): longword;
external 'wrapcallback@files:innocallback.dll stdcall';

function CallNextWNDPROC(idHook: LongWord; Code: Integer; wParam: Word; lParam: TCWPSTRUCT): LongWord;
external 'CallNextHookEx@user32.dll stdcall delayload';

function WrapGETMSGProc(callback:TGETMSGProc; paramcount:integer): longword;
external 'wrapcallback@files:innocallback.dll stdcall';

function CallNextGETMSGPROC(idHook: LongWord; Code: Integer; wParam: Word; lParam: TMSG): LongWord;
external 'CallNextHookEx@user32.dll stdcall delayload';

function WrapKBHookProc(callback:TKBHookProc; paramcount:integer): longword;
external 'wrapcallback@files:innocallback.dll stdcall';

function CallNextKBHook(idHook: LongWord; Code: Integer; wParam: Word; lParam: LongWord): LongWord;
external 'CallNextHookEx@user32.dll stdcall delayload';

function SetCALLWNDPROCHook(HookProc: TCWPSTRUCTProc): LongWord;
var
  pHookFunc: LongWord;
begin
  pHookFunc:= WrapCWPSTRUCTProc(HookProc, 3);
  Result:= SetWindowsHookEx(WH_CALLWNDPROC, pHookFunc, 0, GetCurrentThreadId());
end;

function SetKBHook(HookProc: TKBHookProc): LongWord;
var
  pHookFunc: LongWord;
begin
  pHookFunc:= WrapKBHookProc(HookProc, 3);
  Result:= SetWindowsHookEx(WH_KEYBOARD, pHookFunc, 0, GetCurrentThreadId());
end;

function SetGETMSGHook(HookProc: TGETMSGProc): LongWord;
var
  pHookFunc: LongWord;
begin
  pHookFunc:= WrapGETMSGProc(HookProc, 3);
  Result:= SetWindowsHookEx(WH_GETMESSAGE, pHookFunc, 0, GetCurrentThreadId());
end;

procedure HookFree(HookID: LongWord);
begin
  UnhookWindowsHookEx(HookID);
end;

